<!--
Copyright 2001-2004, TeraQuest Metrics, Inc., All Rights Reserved
Process SubpracticeSet

	Changes
		2004-05-01	Don Oxley			created
		2004-07-10  Bill Cohagan	Modified to accept ns0:BulletedList & ns0:Example elements in input file. These aren't specifically matched,
															but it was necessary to change a w:p[...] into a *[...] so that they would be included in a copy-of.

-->

<!--  TODO:
		(1)	[WLC] It may be possible to refactor using the fencepost pattern in order to make this template consistent with others.

-->

<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	version="1.0"
	xmlns:ns0="http://tempuri.org/XMLSchema.xsd"
	xmlns:w="http://schemas.microsoft.com/office/word/2003/wordml">
<xsl:output method="xml" omit-xml-declaration="no" indent="yes"/>



<xsl:template match="/ | node()| @*">
	<xsl:copy>
		<xsl:apply-templates select="node() | @*"/>
	</xsl:copy>
</xsl:template>

<xsl:template match="ns0:SubpracticeSet">
	<ns0:SubpracticeSet>
		<xsl:choose>
			<xsl:when test="ns0:Subpractice">
				<xsl:copy-of select="."/>
			</xsl:when>
			<xsl:otherwise>
				<ns0:Title>
					<xsl:copy-of select="w:p[1]"/>
				</ns0:Title>

				<xsl:variable name="SG" select="."/>
<!--
<DEBUG subp-count = "{count(w:p[w:pPr/w:pStyle/@w:val = 'subp-statement'])}"/>
-->
				<xsl:for-each select="w:p[w:pPr/w:pStyle/@w:val = 'subp-statement']">
						<xsl:variable name="NextNode" select="generate-id(.)"/>
						<xsl:for-each select="$SG">		<!-- Establish the context as the current ns0:SubpracticeSet node -->  
							<xsl:variable name="First" select="count(w:p[generate-id() = $NextNode]/preceding-sibling::*)" />
							<xsl:variable name="FirstPosition" select = "$First + 1"/>	<!-- Position of "this" subp-statement paragraph -->
							<xsl:variable name="SecondNodeID" select="generate-id(*[position() &gt; $FirstPosition][w:pPr/w:pStyle[@w:val = 'subp-statement']][1])"/>
							<!-- SecondPosition is the position of the next subp-statement paragraph if any, otherwise 1 -->
							<xsl:variable name="SecondPosition" select="count(w:p[generate-id() = $SecondNodeID]/preceding-sibling::*)+1" />
<!--
<DEBUG FirstPosition = "{$FirstPosition}" SecondPosition = "{$SecondPosition}"/>
-->
							<ns0:Subpractice>
								<ns0:SubpracticeNumber>
									<w:p>
										<xsl:copy-of select="*[$FirstPosition]/w:pPr"/>
										<xsl:copy-of select="*[$FirstPosition]/w:r[1]"/>
									</w:p>
								</ns0:SubpracticeNumber>
								<ns0:SubpracticeDelineation>
									<w:p>
										<xsl:copy-of select="*[$FirstPosition]/w:pPr"/>
										<w:r>
											<xsl:copy-of select="*[$FirstPosition]/w:r[2]/w:t"/>
										</w:r>
									</w:p>
								</ns0:SubpracticeDelineation>
								<xsl:choose>
									<xsl:when test="$SecondPosition != 1">  
										<xsl:if test="$SecondPosition &gt; $FirstPosition + 1">
											<!-- There is at least one paragraph following the subp-statement paragraph; treat as DescriptivePart -->
											<ns0:DescriptivePart>
												<xsl:copy-of select = "*[position() &gt; $FirstPosition and position() &lt; $SecondPosition + 1]"/>
											</ns0:DescriptivePart>
										</xsl:if>
									</xsl:when>
									<xsl:when test="*[$FirstPosition + 1]">
										<ns0:DescriptivePart>
											<xsl:copy-of select="*[position() &gt; $FirstPosition]"/>
										</ns0:DescriptivePart>
									</xsl:when>
								</xsl:choose>
							</ns0:Subpractice>
						</xsl:for-each>			
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</ns0:SubpracticeSet>
</xsl:template>

</xsl:stylesheet><!-- Stylus Studio meta-information - (c)1998-2004. Sonic Software Corporation. All rights reserved.
<metaInformation>
<scenarios ><scenario default="yes" name="Scenario1" userelativepaths="yes" externalpreview="no" url="..\io\BL SPractice Expanded.xml" htmlbaseurl="" outputurl="" processortype="msxmldotnet" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext=""/></scenarios><MapperMetaTag><MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no"/><MapperBlockPosition></MapperBlockPosition></MapperMetaTag>
</metaInformation>
-->